#ifndef __DEVICES_H_
#define __DEVICES_H_

#ifdef __DEVICES_C_
#define EXTERN
#else
#define EXTERN extern
#endif

#define MAX_JOY 4

/*** variables ***/

struct joydata_struct
{
   int fd;
   int present;
   int x, y;
   int min_x, min_y;
   int center_x, center_y;
   int max_x, max_y;
   int up, down;
   int left, right;
   int buttons[16];
};

/* joy data */
EXTERN struct joydata_struct joydata[MAX_JOY];
EXTERN void (*joy_poll_func) (void);

/* mouse variables */
EXTERN int		mouse_delta_x;
EXTERN int		mouse_delta_y;
EXTERN int 		mouse_b1;
EXTERN int		mouse_b2;
EXTERN int		mouse_b3;


/*** prototypes ***/
void joy_evaluate_moves(void);
void joy_i386_init(void);
void joy_pad_init(void);
void joy_x11_init(void);

#undef EXTERN
#endif
